/* VisPro/REXX */

_VPAppHandle = VpInit()
if _VPAppHandle='' then exit
_VPAppReturn = 0

/* Open first form */
Parse arg topic
_VPMainWindow = VpOpenForm('', 256, topic)
if _VPMainWindow='' then do
   call VpMessageBox 0,'VisPro/REXX','Unable to open Main form.  Verify that there is a Main form, that it has an id of 256, and that the form has controls within it.'
   signal _VPAppExit
end

do until ( _VPEventCall=='')
   _VPEventCall = VpGetMsg(_VPAppHandle)
   Interpret _VpEventCall
end
/* Terminate application */
_VPAppExit:
call VpQuit _VPAppHandle
return _VPAppReturn


/* ##260_1008.0 */
260_1008.0: /* Event Clicked/selected - reset  1008 */
Arg _eCALCPMHandleNumCol _eCALCself
call VpItem _eCALCPMHandleNumCol,1001,'BACKCOLORRGB', 0
call VpItem _eCALCPMHandleNumCol,1001,'FORECOLORRGB', 65280
call VpItem _eCALCPMHandleNumCol,1001,'FONT', "9.WarpSans"
return

/* ##260_1009.0 */
260_1009.0: /* Event Clicked/selected - reset  1009 */
Arg _eCALCPMHandleNumCol _eCALCself
call VpItem _eCALCPMHandleNumCol,1002,'BACKCOLORRGB', 0
call VpItem _eCALCPMHandleNumCol,1002,'FORECOLORRGB', 16777215
call VpItem _eCALCPMHandleNumCol,1002,'FONT', "9.WarpSans"


return

/* ##260_1010.0 */
260_1010.0: /* Event Clicked/selected - reset  1010 */
Arg _eCALCPMHandleNumCol _eCALCself
call VpItem _eCALCPMHandleNumCol,1000,'BACKCOLORRGB', 13421772
call VpItem _eCALCPMHandleNumCol,1000,'FORECOLORRGB', 0
call VpItem _eCALCPMHandleNumCol,1000,'FONT', "9.WarpSans"
return

/* ##260_1011.0 */
260_1011.0: /* Event Clicked/selected - reset  1011 */
Arg _eCALCPMHandleNumCol _eCALCself
call VpItem _eCALCPMHandleNumCol,1003,'BACKCOLORRGB', 8421504
call VpItem _eCALCPMHandleNumCol,1003,'FORECOLORRGB', 16777215
call VpItem _eCALCPMHandleNumCol,1003,'FONT', "9.WarpSans"


return

/* ##260_1012.0 */
260_1012.0: /* Event Clicked/selected - ~Apply  1012 */
Arg _eCALCPMHandleNumCol self


/* set mainwindow */

rc.1=VpItem(_eCALCPMHandleNumCol,1000,'GETBACKCOLORRGB')
rc.2=VpItem(_eCALCPMHandleNumCol,1003,'GETBACKCOLORRGB')
rc.3=VpItem(_eCALCPMHandleNumCol,1001,'GETBACKCOLORRGB') 
rc.4=VpItem(_eCALCPMHandleNumCol,1002,'GETBACKCOLORRGB') 
rc.5=VpItem(_eCALCPMHandleNumCol,1000,'GETFORECOLORRGB') 
rc.6=VpItem(_eCALCPMHandleNumCol,1003,'GETFORECOLORRGB')
rc.7=VpItem(_eCALCPMHandleNumCol,1001,'GETFORECOLORRGB') 
rc.8=VpItem(_eCALCPMHandleNumCol,1002,'GETFORECOLORRGB') 
rc.9=VpItem(_eCALCPMHandleNumCol,1000,'GETFONT')
rc.10=VpItem(_eCALCPMHandleNumCol,1003,'GETFONT')
rc.11=VpItem(_eCALCPMHandleNumCol,1001,'GETFONT')
rc.12=VpItem(_eCALCPMHandleNumCol,1002,'GETFONT')
call _eCALCApplyFontColor

/* save to INI */
/* format backcolor:forecolor:font */
call SysIni _eCALCprogini, "Setup", "NumButtonLayout", rc.1 || ':' || rc.5 ||':'||rc.9
call SysIni _eCALCprogini, "Setup", "FuncButtonLayout", rc.2 || ':' || rc.6 || ':'||rc.10
call SysIni _eCALCprogini, "Setup", "ResultFieldLayout", rc.3 || ':' || rc.7 ||':'||rc.11
call SysIni _eCALCprogini, "Setup", "EntyFieldLayout", rc.4 || ':' || rc.8 ||':'||rc.12

drop rc.
return

/* ##260_form.1 */
260_form.1: /* Event Form events, Opened */
Arg _eCALCPMHandleNumCol

/* set colors */
CALL VpItem _eCALCPMHandleNumCol, 1000,'BACKCOLORRGB',VpItem(_eCALCPMHandleMain,1008,'GETBACKCOLORRGB') 
CALL VpItem _eCALCPMHandleNumCol, 1003,'BACKCOLORRGB',VpItem(_eCALCPMHandleMain,1011,'GETBACKCOLORRGB')
CALL VpItem _eCALCPMHandleNumCol, 1001,'BACKCOLORRGB',VpItem(_eCALCPMHandleMain,1000,'GETBACKCOLORRGB') 
CALL VpItem _eCALCPMHandleNumCol, 1002,'BACKCOLORRGB',VpItem(_eCALCPMHandleMain,1001,'GETBACKCOLORRGB') 

CALL VpItem _eCALCPMHandleNumCol, 1000,'FORECOLORRGB',VpItem(_eCALCPMHandleMain,1008,'GETFORECOLORRGB') 
CALL VpItem _eCALCPMHandleNumCol, 1003,'FORECOLORRGB',VpItem(_eCALCPMHandleMain,1011,'GETFORECOLORRGB') 
CALL VpItem _eCALCPMHandleNumCol, 1001,'FORECOLORRGB',VpItem(_eCALCPMHandleMain,1000,'GETFORECOLORRGB') 
CALL VpItem _eCALCPMHandleNumCol, 1002,'FORECOLORRGB',VpItem(_eCALCPMHandleMain,1001,'GETFORECOLORRGB') 

/* set fonts */
CALL VpItem _eCALCPMHandleNumCol, 1000,'FONT',VpItem(_eCALCPMHandleMain,1008,'GETFONT') 
CALL VpItem _eCALCPMHandleNumCol, 1003,'FONT',VpItem(_eCALCPMHandleMain,1011,'GETFONT') 
CALL VpItem _eCALCPMHandleNumCol, 1001,'FONT',VpItem(_eCALCPMHandleMain,1000,'GETFONT') 
CALL VpItem _eCALCPMHandleNumCol, 1002,'FONT',VpItem(_eCALCPMHandleMain,1001,'GETFONT') 

/* set sample text */
call VpSetItemValue _eCALCPMHandleNumCol, 1000, '7'
call VpSetItemValue _eCALCPMHandleNumCol, 1003, '+'
call VpSetItemValue _eCALCPMHandleNumCol, 1001, '27'
call VpSetItemValue _eCALCPMHandleNumCol, 1002, '3*9'

/* set language strings */
call _eCALCSetLang 'NB1'
return

/* ##259_1003.0 */
259_1003.0: Arg _eCALCABOUTDLG

CALL VpWindow _eCALCABOUTDLG ,'CLOSE'

return

/* ##259_form.1 */
259_form.1: Arg _eCALCABOUTDLG 
/* Get window size */
PARSE VALUE VpWindow(_eCALCABOUTDLG,'GETSIZE') with _eCALCx1 _eCALCy1
/* Get screen size */
PARSE VALUE VpWindow(_eCALCABOUTDLG,'GETSCREENSIZE') with _eCALCx2 _eCALCy2
_eCALCx = (_eCALCx2 - _eCALCx1)%2
_eCALCy = (_eCALCy2 - _eCALCy1)%2
CALL VpWindow _eCALCABOUTDLG,'SETPOS',_eCALCx,_eCALCy,_eCALCx1,_eCALCy1
CALL VpSetItemValue _eCALCABOUTDLG,1001,VpLoadPicture('RESICON',2000)
CALL VpWindow _eCALCABOUTDLG,'SETTITLE',strip(VpGetItemValue(_eCALCPMHandleMain, 259), 'B', '~')

return

/* ##256_1000.1 */
256_1000.1: /* Event Enter -   1000 */
Arg _eCALCPMHandleMain _eCALCItemhandle

return

/* ##256_1000.7 */
256_1000.7: /* Event Popup menu -   1000 */
Arg _eCALCPMHandleMain _eCALCItemhandle
CALL VpItem _eCALCPMHandleMain, 299, 'DISABLE'
CALL VpWindow _eCALCPMHandleMain, 'POPUP', 256


return

/* ##256_1001.1 */
256_1001.1: /* Event Enter -   1001 */
Arg _eCALCPMHandleMain _eCALCItemhandle



return

/* ##256_1001.3 */
256_1001.3: /* Event Changed -   1001 */
Arg _eCALCPMHandleMain self

call _eCALCcalculate


return

/* ##256_1001.6 */
256_1001.6: /* Event Drag drop -   1001 */
Arg _eCALCPMHandleMain _eCALCself

_eCALCdropfile = VPDROPINFO.1.3||VPDROPINFO.1.4

if _eCALCdropfile >< "" then do
 if translate(stream(_eCALCdropfile,"C",QUERY EXISTS)) = translate(_eCALCdropfile) then do 
   _eCALCrc = linein(_eCALCdropfile,1)
   if _eCALCrc >< "" then CALL VpAddItem _eCALCPMHandleMain, 1001, 'CURRENT', _eCALCrc
  end
 call stream _eCALCdropfile,'c','close'
 end

drop _eCALCdropfile VPDROPINFO.
return

/* ##256_1001.7 */
256_1001.7: /* Event Popup menu -   1001 */
Arg PMHandleMain _eCALCItemhandle
CALL VpItem _eCALCPMHandleMain, 299, 'ENABLE'
CALL VpWindow PMHandleMain, 'POPUP', 256
return

/* ##256_1002.0 */
256_1002.0: Arg _eCALCPMHandleMain

Llave = 1
CALL numPress _eCALCPMHandleMain

return

/* ##256_1003.0 */
256_1003.0: Arg _eCALCPMHandleMain

Llave = 2
CALL numPress _eCALCPMHandleMain

return

/* ##256_1004.0 */
256_1004.0: Arg _eCALCPMHandleMain

Llave = 3
CALL numPress _eCALCPMHandleMain

return

/* ##256_1005.0 */
256_1005.0: Arg _eCALCPMHandleMain

Llave = 4
CALL numPress _eCALCPMHandleMain

return

/* ##256_1006.0 */
256_1006.0: Arg _eCALCPMHandleMain

Llave = 5
CALL numPress _eCALCPMHandleMain

return

/* ##256_1007.0 */
256_1007.0: Arg _eCALCPMHandleMain

Llave = 6
CALL numPress _eCALCPMHandleMain

return

/* ##256_1008.0 */
256_1008.0: Arg _eCALCPMHandleMain

Llave = 7
CALL numPress _eCALCPMHandleMain

return

/* ##256_1009.0 */
256_1009.0: Arg _eCALCPMHandleMain

Llave = 8
CALL numPress _eCALCPMHandleMain

return

/* ##256_1010.0 */
256_1010.0: Arg _eCALCPMHandleMain

Llave = 9
CALL numPress _eCALCPMHandleMain

return

/* ##256_1011.0 */
256_1011.0: Arg _eCALCPMHandleMain

Llave = '+'
CALL funcPres _eCALCPMHandleMain

return

/* ##256_1012.0 */
256_1012.0: Arg _eCALCPMHandleMain

Llave = 0
CALL numPress _eCALCPMHandleMain
return

/* ##256_1013.0 */
256_1013.0: Arg _eCALCPMHandleMain

Llave = '-'
CALL funcPres _eCALCPMHandleMain

return

/* ##256_1014.0 */
256_1014.0: Arg _eCALCPMHandleMain

Llave = '('
CALL funcPres _eCALCPMHandleMain

return

/* ##256_1015.0 */
256_1015.0: Arg _eCALCPMHandleMain

Llave = '*'
CALL funcPres _eCALCPMHandleMain

return

/* ##256_1016.0 */
256_1016.0: Arg _eCALCPMHandleMain

Llave = '/'
CALL funcPres _eCALCPMHandleMain

return

/* ##256_1017.0 */
256_1017.0: Arg _eCALCPMHandleMain

Llave = '.'
CALL numPress _eCALCPMHandleMain

return

/* ##256_1020.0 */
256_1020.0: Arg _eCALCPMHandleMain

CALL VpSetItemValue _eCALCPMHandleMain,1001,""
CALL VpSetItemValue _eCALCPMHandleMain,1000,""
return

/* ##256_1021.0 */
256_1021.0: /* Event Clicked/selected - )  1021 */
Arg _eCALCPMHandleMain

Llave = ')'
CALL funcPres _eCALCPMHandleMain

return

/* ##256_256.0 */
256_256.0: /* Menu events - ~Edit */
Arg _eCALCPMHandleMain _eCALCself
if _eCALCItemhandle = 1000 then CALL VpItem _eCALCPMHandleMain, 299, 'DISABLE'
else CALL VpItem _eCALCPMHandleMain, 299, 'ENABLE'
return

/* ##256_258.0 */
256_258.0: Arg PMHandleMain

if _eCALCItemhandle = 1001 then CALL VpItem PMHandleMain,1001,'SENDMSG','0x01d9'
if _eCALCItemhandle = 1000 then CALL VpItem PMHandleMain,1000,'SENDMSG','0x0145'

return

/* ##256_259.0 */
256_259.0: Arg _eCALCPMHandleMain

value=VpOpenForm(_eCALCPMHandleMain,259,'topic name')

return

/* ##256_260.0 */
256_260.0: Arg _eCALCPMHandleMain

whichKey = 1006
CALL PressKey _eCALCPMHandleMain

Llave = 5
CALL numPress _eCALCPMHandleMain

return

/* ##256_262.0 */
256_262.0: Arg _eCALCPMHandleMain

whichKey = 1002
CALL PressKey _eCALCPMHandleMain

Llave = 1
CALL numPress _eCALCPMHandleMain

return

/* ##256_263.0 */
256_263.0: Arg _eCALCPMHandleMain

whichKey = 1012
CALL PressKey _eCALCPMHandleMain

Llave = 0
CALL numPress _eCALCPMHandleMain

return

/* ##256_264.0 */
256_264.0: Arg _eCALCPMHandleMain

whichKey = 1003
CALL PressKey _eCALCPMHandleMain

Llave = 2
CALL numPress _eCALCPMHandleMain

return

/* ##256_265.0 */
256_265.0: Arg _eCALCPMHandleMain

whichKey = 1004
CALL PressKey _eCALCPMHandleMain

Llave = 3
CALL numPress _eCALCPMHandleMain

return

/* ##256_266.0 */
256_266.0: Arg _eCALCPMHandleMain

whichKey = 1005
CALL PressKey _eCALCPMHandleMain

Llave = 4
CALL numPress _eCALCPMHandleMain

return

/* ##256_267.0 */
256_267.0: Arg _eCALCPMHandleMain

whichKey = 1006
CALL PressKey _eCALCPMHandleMain

Llave = 5
CALL numPress _eCALCPMHandleMain

return

/* ##256_268.0 */
256_268.0: Arg _eCALCPMHandleMain

whichKey = 1007
CALL PressKey _eCALCPMHandleMain

Llave = 6
CALL numPress _eCALCPMHandleMain

return

/* ##256_269.0 */
256_269.0: Arg _eCALCPMHandleMain

whichKey = 1008
CALL PressKey _eCALCPMHandleMain

Llave = 7
CALL numPress _eCALCPMHandleMain

return

/* ##256_270.0 */
256_270.0: Arg _eCALCPMHandleMain

whichKey = 1009
CALL PressKey _eCALCPMHandleMain

Llave = 8
CALL numPress _eCALCPMHandleMain

return

/* ##256_271.0 */
256_271.0: Arg _eCALCPMHandleMain

whichKey = 1010
CALL PressKey _eCALCPMHandleMain

Llave = 9
CALL numPress _eCALCPMHandleMain

return

/* ##256_272.0 */
256_272.0: /* Menu events - Hide ~Keyboard */
Arg _eCALCPMHandleMain


if VpIsSelected(_eCALCPMHandleMain,272) = 0 then do
	call VpSelect _eCALCPMHandleMain, 272, 1

	/* hide buttons */
	do _eCALCi = 1002 to 1021
	 CALL VpItem _eCALCPMHandleMain, _eCALCi, 'HIDE' 
	end /* end do */


	/* get item size */
	parse value VpItem(_eCALCPMHandleMain,1000, 'ITEMSIZE') with _eCALCXsizeItem _eCALCYsizeItem

	/* adjust window size */
	PARSE VALUE VpWindow(_eCALCPMHandleMain,'GETPOS') with _eCALCXpos _eCALCYpos
	PARSE VALUE VpWindow(_eCALCPMHandleMain,'GETSIZE') with _eCALCXsize _eCALCYsize

	CALL VpWindow _eCALCPMHandleMain, 'SETPOS', _eCALCXpos, _eCALCYpos+_eCALCYsize-(_eCALCYsizeItem*2+menusize), _eCALCXsize, _eCALCYsizeItem*2+menusize

	/* move entry fields ro buttom - is done in 'when sized ...' event */

	/* set flag for 'when resized' */
	HiddenKeyboard=1

end
else do
	call VpSelect _eCALCPMHandleMain, 272, 0

	/* get item size */
	parse value VpItem(_eCALCPMHandleMain,1000, 'ITEMSIZE') with _eCALCXsizeItem _eCALCYsizeItem

	/* adjust window size */
	PARSE VALUE VpWindow(_eCALCPMHandleMain,'GETPOS') with _eCALCXpos _eCALCYpos
	PARSE VALUE VpWindow(_eCALCPMHandleMain,'GETSIZE') with _eCALCXsize _eCALCYsize
	CALL VpWindow _eCALCPMHandleMain, 'SETPOS', _eCALCXpos, _eCALCYpos+_eCALCYsize-((_eCALCYsizeItem-7)*7+menusize), _eCALCXsize, (_eCALCYsizeItem-7)*7+menusize

	/* show buttons */
	do _eCALCi = 1002 to 1021
	 CALL VpItem _eCALCPMHandleMain, _eCALCi, 'SHOW' 
	end /* end do */

	/* set flag for 'when resized' */
	HiddenKeyboard=0



end





return

/* ##256_273.0 */
256_273.0: Arg _eCALCPMHandleMain

whichKey = 1011
CALL PressKey _eCALCPMHandleMain

Llave = '+'
CALL funcPres _eCALCPMHandleMain

return

/* ##256_274.0 */
256_274.0: Arg _eCALCPMHandleMain

whichKey = 1013
CALL PressKey _eCALCPMHandleMain

Llave = '-'
CALL funcPres _eCALCPMHandleMain

return

/* ##256_275.0 */
256_275.0: Arg _eCALCPMHandleMain

whichKey = 1015
CALL PressKey _eCALCPMHandleMain

Llave = '*'
CALL funcPres _eCALCPMHandleMain

return

/* ##256_276.0 */
256_276.0: Arg _eCALCPMHandleMain

whichKey = 1016
CALL PressKey _eCALCPMHandleMain

Llave = '/'
CALL funcPres _eCALCPMHandleMain

return

/* ##256_277.0 */
256_277.0: Arg _eCALCPMHandleMain

whichKey = 1017
CALL PressKey _eCALCPMHandleMain

Llave = _eCALCdelimiter
CALL numPress _eCALCPMHandleMain

return

/* ##256_278.0 */
256_278.0: /* Menu events - General Help */
Arg _eCALCPMHandleMain self

/* CALL VpWindow _eCALCPMHandleMain,'EXTENDEDHELP' */

/* open manual file */

if _eCALChelpfile >< "_ECALCHELPFILE" then call SysOpenObject _eCALChelpfile,0,'TRUE'
return

/* ##256_279.0 */
256_279.0: Arg _eCALCPMHandleMain

whichKey = 1012
CALL PressKey _eCALCPMHandleMain

Llave = 0
CALL numPress _eCALCPMHandleMain

return

/* ##256_280.0 */
256_280.0: Arg _eCALCPMHandleMain

whichKey = 1002
CALL PressKey _eCALCPMHandleMain

Llave = 1
CALL numPress _eCALCPMHandleMain

return

/* ##256_281.0 */
256_281.0: Arg _eCALCPMHandleMain

whichKey = 1003
CALL PressKey _eCALCPMHandleMain

Llave = 2
CALL numPress _eCALCPMHandleMain


return

/* ##256_282.0 */
256_282.0: Arg _eCALCPMHandleMain

whichKey = 1004
CALL PressKey _eCALCPMHandleMain

Llave = 3
CALL numPress _eCALCPMHandleMain


return

/* ##256_283.0 */
256_283.0: Arg _eCALCPMHandleMain

whichKey = 1005
CALL PressKey _eCALCPMHandleMain

Llave = 4
CALL numPress _eCALCPMHandleMain


return

/* ##256_284.0 */
256_284.0: Arg _eCALCPMHandleMain

whichKey = 1007
CALL PressKey _eCALCPMHandleMain

Llave = 6
CALL numPress _eCALCPMHandleMain


return

/* ##256_285.0 */
256_285.0: Arg _eCALCPMHandleMain

whichKey = 1008
CALL PressKey _eCALCPMHandleMain

Llave = 7
CALL numPress _eCALCPMHandleMain


return

/* ##256_286.0 */
256_286.0: Arg _eCALCPMHandleMain

whichKey = 1009
CALL PressKey _eCALCPMHandleMain

Llave = 8
CALL numPress _eCALCPMHandleMain


return

/* ##256_287.0 */
256_287.0: Arg _eCALCPMHandleMain

whichKey = 1010
CALL PressKey _eCALCPMHandleMain

Llave = 9
CALL numPress _eCALCPMHandleMain


return

/* ##256_288.0 */
256_288.0: Arg _eCALCPMHandleMain

whichKey = 1017
CALL PressKey _eCALCPMHandleMain

Llave = _eCALCdelimiter
CALL numPress _eCALCPMHandleMain


return

/* ##256_289.0 */
256_289.0: /* Menu events - ~Always On Top */
Arg _eCALCPMHandleMain

if VpIsSelected(_eCALCPMHandleMain,289) = 0 then do
call VpSelect _eCALCPMHandleMain, 289, 1
call _eCALCfloat _eCALChwndFrame, 1, _eCALCPMHandleMain
end
else do
call VpSelect _eCALCPMHandleMain, 289, 0
call _eCALCfloat _eCALChwndFrame, 0, _eCALCPMHandleMain
end
return

/* ##256_290.0 */
256_290.0: Arg _eCALCPMHandleMain

whichKey = 1020
CALL PressKey _eCALCPMHandleMain
CALL VpSetItemValue _eCALCPMHandleMain,1001,""
CALL VpSetItemValue _eCALCPMHandleMain,1000,""
return

/* ##256_291.0 */
256_291.0: /* Menu events - ( */
Arg _eCALCPMHandleMain

whichKey = 1014
CALL PressKey _eCALCPMHandleMain

Llave = "("
CALL numPress _eCALCPMHandleMain


return

/* ##256_293.0 */
256_293.0: Arg _eCALCPMHandleMain

whichKey = 1020
CALL PressKey _eCALCPMHandleMain

CALL VpSetItemValue _eCALCPMHandleMain,1001,""
CALL VpSetItemValue _eCALCPMHandleMain,1000,""
return

/* ##256_294.0 */
256_294.0: /* Menu events - Auto~clip */

if VpIsSelected(_eCALCPMHandleMain,294) = 0 then do
call VpSelect _eCALCPMHandleMain, 294, 1
_eCALCAuotClip = 1
end
else do
call VpSelect _eCALCPMHandleMain, 294, 0
_eCALCAuotClip = 0
end
return

/* ##256_295.0 */
256_295.0: /* Menu events - ( */
Arg _eCALCPMHandleMain

whichKey = 1021
CALL PressKey _eCALCPMHandleMain

Llave = ")"
CALL numPress _eCALCPMHandleMain


return

/* ##256_296.0 */
256_296.0: /* Menu events - /-num */
Arg _eCALCPMHandleMain

whichKey = 1016
CALL PressKey _eCALCPMHandleMain

Llave = '/'
CALL funcPres _eCALCPMHandleMain



return

/* ##256_297.0 */
256_297.0: /* Menu events - * */

whichKey = 1015
CALL PressKey _eCALCPMHandleMain

Llave = '*'
CALL funcPres _eCALCPMHandleMain



return

/* ##256_298.0 */
256_298.0: /* Menu events - enter */

NOP
return

/* ##256_299.0 */
256_299.0: /* Menu events - ~Paste	Shift+Ins */
call _eCALCCopyFromClipBoard
/* old:
if _eCALCItemhandle = 1001 then CALL VpItem _eCALCPMHandleMain,1001,'SENDMSG','0x01da'
if _eCALCItemhandle = 1000 then CALL VpItem _eCALCPMHandleMain,1000,'SENDMSG','0x0147' 
*/
return

/* ##256_301.0 */
256_301.0: /* Menu events - ~Settings */
Arg _eCALCPMHandleMain self
value=VpOpenForm(_eCALCPMHandleMain,257,'topic name')
return

/* ##256_303.0 */
256_303.0: /* Menu events - ~0 */
Arg _eCALCPMHandleMain _eCALCself
call _eCALCSetPrecision _eCALCself
return

/* ##256_304.0 */
256_304.0: /* Menu events - ~1 */
Arg _eCALCPMHandleMain _eCALCself
call _eCALCSetPrecision _eCALCself


return

/* ##256_305.0 */
256_305.0: /* Menu events - ~2 */
Arg _eCALCPMHandleMain _eCALCself
call _eCALCSetPrecision _eCALCself


return

/* ##256_306.0 */
256_306.0: /* Menu events - ~3 */
Arg _eCALCPMHandleMain _eCALCself
call _eCALCSetPrecision _eCALCself




return

/* ##256_307.0 */
256_307.0: /* Menu events - ~4 */
Arg _eCALCPMHandleMain _eCALCself
call _eCALCSetPrecision _eCALCself




return

/* ##256_308.0 */
256_308.0: /* Menu events - ~5 */
Arg _eCALCPMHandleMain _eCALCself
call _eCALCSetPrecision _eCALCself




return

/* ##256_309.0 */
256_309.0: /* Menu events - ~6 */
Arg _eCALCPMHandleMain _eCALCself
call _eCALCSetPrecision _eCALCself




return

/* ##256_310.0 */
256_310.0: /* Menu events - ~7 */
Arg _eCALCPMHandleMain _eCALCself
call _eCALCSetPrecision _eCALCself




return

/* ##256_311.0 */
256_311.0: /* Menu events - ~8 */
Arg _eCALCPMHandleMain _eCALCself
call _eCALCSetPrecision _eCALCself




return

/* ##256_312.0 */
256_312.0: /* Menu events - ~9 */
Arg _eCALCPMHandleMain _eCALCself
call _eCALCSetPrecision _eCALCself




return

/* ##256_313.0 */
256_313.0: /* Menu events - ~Disable */
Arg _eCALCPMHandleMain _eCALCself
call _eCALCSetPrecision _eCALCself

return

/* ##256_314.0 */
256_314.0: /* Menu events - ~Default */
Arg _eCALCPMHandleMain _eCALCself
call _eCALCSetPrecision _eCALCself

return

/* ##256_316.0 */
256_316.0: /* Menu events - ~comma */
Arg _eCALCPMHandleMain _eCALCself
call VpSelect _eCALCPMHandleMain,318,0
call VpSelect _eCALCPMHandleMain,316,1
call VpSelect _eCALCPMHandleMain,317,0
_eCALCdelimiter = ','
_eCALCdelimiter_System_Default=0
return

/* ##256_317.0 */
256_317.0: /* Menu events - ~dot */
Arg _eCALCPMHandleMain _eCALCself
call VpSelect _eCALCPMHandleMain,318,0
call VpSelect _eCALCPMHandleMain,316,0
call VpSelect _eCALCPMHandleMain,317,1
_eCALCdelimiter = '.'
_eCALCdelimiter_System_Default=0
return

/* ##256_318.0 */
256_318.0: /* Menu events - ~system default */
Arg _eCALCPMHandleMain _eCALCself
call VpSelect _eCALCPMHandleMain,318, 1
call VpSelect _eCALCPMHandleMain,316,0
call VpSelect _eCALCPMHandleMain,317,0
_eCALCdelimiter = _eCALCsystemdelimiter
_eCALCdelimiter_System_Default=1
return

/* ##256_319.0 */
256_319.0: /* Menu events - F3 */
Arg _eCALCPMHandleMain
CALL VpWindow _eCALCPMHandleMain,'CLOSE'



return

/* ##256_320.0 */
256_320.0: /* Menu events - Paste Strng+V */
call _eCALCCopyFromClipBoard
return

/* ##256_321.0 */
256_321.0: /* Menu events - Put in Brackets */
call _eCALCPutInBrackets

return

/* ##256_form.1 */
256_form.1: /* eCalc.EXE        */
/* -> v1.3 By Nicky Morrow  */
/* v2.0 By Frank Wochatz  */
/* For eCS          */
/* VisPro REXX v3.1 */
Arg _eCALCPMHandleMain

NumericDigits = 15

/* build INI file name */
parse source . . _eCALCpgmname
_eCALCpath=filespec("D",_eCALCpgmname)||filespec("P",_eCALCpgmname)
_eCALCUserIniPath = filespec("D",Value('USER_INI',,'OS2ENVIRONMENT')) || filespec("P",Value('USER_INI',,'OS2ENVIRONMENT'))
_eCALCprogini = _eCALCpath ||'ECALC.INI'

Numeric digits NumericDigits

IF RxFuncQuery('SysLoadFuncs') THEN
  DO
    CALL RxFuncAdd 'SysLoadFuncs','RexxUtil','SysLoadFuncs'
    CALL SysLoadFuncs
  END

IF RxFuncQuery('MathLoadFuncs') THEN
  DO
    call RxFuncAdd "MathLoadFuncs","RxMathFn","MathLoadFuncs"
    call MathLoadFuncs
  END

_eCALCrc = SysIni(_eCALCprogini, "WinPos", "main")
if _eCALCrc >< 'ERROR:' then do
 parse var _eCALCrc _eCALCxpos ':' _eCALCypos ':' _eCALCxsize ':' _eCALCysize
end
else do
 _eCALCxsize = 320
 _eCALCysize = 320

/* center window */
parse value VpWindow(_eCALCPMHandleMain,'GETSCREENSIZE') with _eCALCxScrSize _eCALCyScrSize
_eCALCxpos = (_eCALCxScrSize - _eCALCxsize)%2
_eCALCypos = (_eCALCyScrSize - _eCALCysize)%2
end

CALL VpWindow _eCALCPMHandleMain,'SETPOS', _eCALCxpos, _eCALCypos, _eCALCxsize, _eCALCysize


CALL VpItem _eCALCPMHandleMain,261,'HIDE'

/* set item colors and fonts */
rc= SysIni(_eCALCprogini, "Setup", "NumButtonLayout") 
if rc >< "ERROR:" then parse var rc rc.1 ':' rc.5 ':' rc.9
else do
rc.1=13421772
rc.5=0
rc.9="9.WarpSans"
end
rc= SysIni(_eCALCprogini, "Setup", "FuncButtonLayout")
if rc >< "ERROR:" then parse var rc rc.2 ':' rc.6 ':' rc.10
else do
rc.2=8421504
rc.6=16777215
rc.10="9.WarpSans"
end

rc= SysIni(_eCALCprogini, "Setup", "ResultFieldLayout")
if rc >< "ERROR:" then parse var rc rc.3  ':' rc.7 ':'  rc.11
else do
rc.3=0
rc.7=65280
rc.11="9.WarpSans"
end


rc= SysIni(_eCALCprogini, "Setup", "EntyFieldLayout")
if rc >< "ERROR:" then parse var rc rc.4  ':'  rc.8  ':' rc.12
else do
rc.4=0
rc.8=16777215
rc.12="9.WarpSans"
end
call _eCALCApplyFontColor
drop rc.

/* always on top ? */
/* init float on top */
/* initialize OS2apirx.dll and get parent handle */
_eCALChwndFrame=_eCALCinitFloat(_eCALCPMHandleMain)
if SysIni(_eCALCprogini, "Setup", "Float") = 1 then call VpSelect _eCALCPMHandleMain, 289



/* hide keyboard ? */
if SysIni(_eCALCprogini, "Setup", "KeyHide") = 1 then do
call VpSelect _eCALCPMHandleMain, 272
HiddenKeyboard=1
end


/* hide keyboard ? */
parse value VpItem(_eCALCPMHandleMain,1000, 'ITEMSIZE') with dummy _eCALCYsizeItem
parse value VpItem(_eCALCPMHandleMain,1000, 'ITEMPOS') with dummy _eCALCYPosItem
/* get menu and window bar height, requ. for resizing */
menusize = _eCALCysize - _eCALCYsizeItem - _eCALCYPosItem

/* autoclip ? */
if SysIni(_eCALCprogini, "Setup", "AutoClip") = 1 then do
call VpSelect _eCALCPMHandleMain, 294, 1
_eCALCAuotClip = 1 
end

/* enable drag and drop */
CALL VpWindow _eCALCPMHandleMain,'SETFORMDRAGINFO',1,,'<DRM_OS2FILE,DRF_TEXT>',0,0,0,'COPY'


/* set precision, prec: 0,1,2,3...9  item 303,304,305....314 */
/* -1 = disabled, item = 313 */
/* -2 = fefault (system nationale), item = 314 */
_eCALCprecision = SysIni(_eCALCprogini, "Setup", "Precision")
if _eCALCprecision = "ERROR:" then _eCALCprecision = -2

/* read system setting for output digits */
_eCALCsystemprecision = strip(SysIni("USER", "PM_National", "iDigits"), 'T', '00'x)
if _eCALCsystemprecision = 'ERROR:' then _eCALCsystemprecision = -1

Select
when _eCALCprecision = -1 then call VpSelect _eCALCPMHandleMain, 313, 1
when _eCALCprecision = -2 then call VpSelect _eCALCPMHandleMain, 314, 1
otherwise call VpSelect _eCALCPMHandleMain, _eCALCprecision + 303, 1
end /*select */

/* read setting for decimal delimiter */
_eCALCsystemdelimiter = strip(SysIni("USER", "PM_National", "sDecimal"),'T', '00'x)
if _eCALCsystemdelimiter =  'ERROR:' then _eCALCsystemdelimiter = '.'

_eCALCdelimiter = SysIni(_eCALCprogini, "Setup", "Delimiter")
if _eCALCdelimiter = 'ERROR:' | _eCALCdelimiter = -1 then do
_eCALCdelimiter_System_Default=1
_eCALCdelimiter = _eCALCsystemdelimiter
end

Select
when _eCALCdelimiter_System_Default=1 then call VpSelect _eCALCPMHandleMain, 318, 1
when _eCALCdelimiter = '.' then call VpSelect _eCALCPMHandleMain, 317, 1
when _eCALCdelimiter = ',' then call VpSelect _eCALCPMHandleMain, 316, 1
otherwise call VpSelect _eCALCPMHandleMain, 318, 1
end


/* NLS */
_eCALClanguage = left(Value('Lang',,'OS2ENVIRONMENT'),2)

if _eCALClanguage >< "" then do
_eCALClanguagefile = _eCALCpath || 'LANG\'||_eCALClanguage||'.dat'

/* read language file if available */
if translate(stream(_eCALClanguagefile,"C",QUERY EXISTS)) = translate(_eCALClanguagefile) then call _eCALCreadlang

call _eCALCSetLang 'MAIN'
end

_eCALChelpfile = _eCALCpath || 'LANG\'||_eCALClanguage||'.inf'
if translate(stream(_eCALChelpfile,"C",QUERY EXISTS)) >< translate(_eCALChelpfile) then _eCALChelpfile = _eCALCpath || 'LANG\'||_eCALClanguage||'.txt'
if translate(stream(_eCALChelpfile,"C",QUERY EXISTS)) >< translate(_eCALChelpfile) then do
	_eCALChelpfile = _eCALCpath || 'LANG\en.inf'
	if translate(stream(_eCALChelpfile,"C",QUERY EXISTS)) >< translate(_eCALChelpfile) then _eCALChelpfile = _eCALCpath || 'LANG\en.txt'
	if translate(stream(_eCALChelpfile,"C",QUERY EXISTS)) >< translate(_eCALChelpfile) then drop _eCALChelpfile
/* say _eCALChelpfile */

end
return

/* ##256_form.13 */
256_form.13: /* Form events - Sized */
Arg _eCALCPMHandleMain

/* if KeyBoard is hidden, adjust item position */


/* workaround for system f when minmize floated window with ePager */
if VpWindow(_eCALCPMHandleMain,'GETPOS') = "-32000 -32000" then do

if VpIsSelected(_eCALCPMHandleMain,289) = 1 then do
call VpSelect _eCALCPMHandleMain, 289, 0
call _eCALCfloat _eCALChwndFrame, 0, _eCALCPMHandleMain
end



end





if HiddenKeyboard=1 then do

	/* get item size */
	parse value VpItem(_eCALCPMHandleMain,1000, 'ITEMSIZE') with _eCALCXsizeItem _eCALCYsizeItem
	
	/* get new window size */
	PARSE VALUE VpWindow(_eCALCPMHandleMain,'GETSIZE') with _eCALCXsize _eCALCYsize

	/* move entry fields to buttom */
	CALL VpItem _eCALCPMHandleMain, 1001, 'SETITEMPOS',0,0,_eCALCXsize-7,(_eCALCYsize-menusize)%2
	CALL VpItem _eCALCPMHandleMain, 1000, 'SETITEMPOS',0,((_eCALCYsize-menusize)%2)+3,_eCALCXsize-7,(_eCALCYsize-menusize)%2
end

return

/* ##256_form.2 */
256_form.2: Arg _eCALCPMHandleMain 

parse value VpWindow(_eCALCPMHandleMain,'GETPOS') with _eCALCxpos _eCALCypos
parse value VpWindow(_eCALCPMHandleMain,'GETSIZE') with _eCALCxsize _eCALCysize
_eCALCrc = SysIni(_eCALCprogini, "WinPos", "main",_eCALCxpos||':'||_eCALCypos||':'||_eCALCxsize||':'||_eCALCysize )


/* save float state */
call SysIni _eCALCprogini, "Setup", "Float", VpIsSelected(_eCALCPMHandleMain, 289)

/* save keyboard hide setting */
call SysIni _eCALCprogini, "Setup", "KeyHide", VpIsSelected(_eCALCPMHandleMain, 272)

/* save autoclip state */
call SysIni _eCALCprogini, "Setup", "AutoClip", VpIsSelected(_eCALCPMHandleMain, 294)

/* save precision setting */
call SysIni _eCALCprogini, "Setup", "Precision", _eCALCprecision

/* save delimiter setting */

if _eCALCdelimiter_System_Default=1 then call SysIni _eCALCprogini, "Setup", "Delimiter", '-1'
else call SysIni _eCALCprogini, "Setup", "Delimiter", _eCALCdelimiter



return

/* ##257_form.1 */
257_form.1: /* Event Form events, Opened */
Arg _eCALCPMHandleSettings
/*
/* set window position */
rc = SysIni(_eCALCprogini, "propwin", "proppos")
if _eCALCrc >< 'ERROR:' then do
 parse var _eCALCrc _eCALCsetxpos ':' _eCALCsetypos ':' _eCALCsetxsize ':' _eCALCsetysize
 CALL VpWindow _eCALCPMHandleSettings,'SETPOS', _eCALCsetxpos, _eCALCsetypos, _eCALCsetxsize, _eCALCsetysize
end
*/

/* load notebook forms */

_eCALCPMHandleNumCol=VpOpenForm(_eCALCPMHandleSettings, 260, "dummy")
_eCALCPMHandleNumColindex= VpAddItem(_eCALCPMHandleSettings, 1000, '~Fonts & Colors',  _eCALCPMHandleNumCol)


return

/* ##257_form.2 */
257_form.2: /* Event Form events, Closed */
Arg window 
/*
call VpWindow Watermark_nb, 'CLOSE'

/* save window position*/
parse value VpWindow(notebookhandle,"GETSIZE") with xsize ysize
parse value VpWindow(notebookhandle,"GETPOS") with xpos ypos
rc = xpos||':'||ypos||':'||xsize||':'||ysize
rc = SysIni(progini, "propwin", "proppos", rc)
*/
return

/* ##SUB_funcpres */
funcpres: /* FUNCPRES */
arg _eCALCPMHandleMain
CALL VpAddItem _eCALCPMHandleMain, 1001, 'CURRENT', Llave
return

/* ##SUB_numpress */
numpress: /* NUMPRESS */
ARG _eCALCPMHandleMain
CALL VpAddItem _eCALCPMHandleMain, 1001, 'CURRENT', Llave

return

/* ##SUB_presskey */
presskey: /* PRESSKEY */
Arg _eCALCPMHandleMain
CALL VpItem _eCALCPMHandleMain,whichKey,'SENDMSG','0x0123','1','0'
CALL VpThread 'SLEEP',35
CALL VpItem _eCALCPMHandleMain,whichKey,'SENDMSG','0x0123','0','0'

return

/* ##SUB__ecalcapplyfontcolor */
_ecalcapplyfontcolor: /* */

/* set colors */
CALL VpItem _eCALCPMHandleMain, 1002,'BACKCOLORRGB', rc.1
CALL VpItem _eCALCPMHandleMain, 1003,'BACKCOLORRGB', rc.1
CALL VpItem _eCALCPMHandleMain, 1004,'BACKCOLORRGB', rc.1
CALL VpItem _eCALCPMHandleMain, 1005,'BACKCOLORRGB', rc.1
CALL VpItem _eCALCPMHandleMain, 1006,'BACKCOLORRGB', rc.1
CALL VpItem _eCALCPMHandleMain, 1007,'BACKCOLORRGB', rc.1
CALL VpItem _eCALCPMHandleMain, 1008,'BACKCOLORRGB', rc.1
CALL VpItem _eCALCPMHandleMain, 1009,'BACKCOLORRGB', rc.1
CALL VpItem _eCALCPMHandleMain, 1010,'BACKCOLORRGB', rc.1
CALL VpItem _eCALCPMHandleMain, 1012,'BACKCOLORRGB', rc.1
CALL VpItem _eCALCPMHandleMain, 1017,'BACKCOLORRGB', rc.1

CALL VpItem _eCALCPMHandleMain, 1011,'BACKCOLORRGB', rc.2
CALL VpItem _eCALCPMHandleMain, 1013,'BACKCOLORRGB', rc.2
CALL VpItem _eCALCPMHandleMain, 1014,'BACKCOLORRGB', rc.2
CALL VpItem _eCALCPMHandleMain, 1015,'BACKCOLORRGB', rc.2
CALL VpItem _eCALCPMHandleMain, 1016,'BACKCOLORRGB', rc.2
CALL VpItem _eCALCPMHandleMain, 1020,'BACKCOLORRGB', rc.2
CALL VpItem _eCALCPMHandleMain, 1021,'BACKCOLORRGB', rc.2
CALL VpItem _eCALCPMHandleMain, 1000,'BACKCOLORRGB',rc.3
CALL VpItem _eCALCPMHandleMain, 1001,'BACKCOLORRGB',rc.4

CALL VpItem _eCALCPMHandleMain, 1002,'FORECOLORRGB',rc.5
CALL VpItem _eCALCPMHandleMain, 1003,'FORECOLORRGB',rc.5
CALL VpItem _eCALCPMHandleMain, 1004,'FORECOLORRGB',rc.5
CALL VpItem _eCALCPMHandleMain, 1005,'FORECOLORRGB',rc.5
CALL VpItem _eCALCPMHandleMain, 1006,'FORECOLORRGB',rc.5
CALL VpItem _eCALCPMHandleMain, 1007,'FORECOLORRGB',rc.5

CALL VpItem _eCALCPMHandleMain, 1008,'FORECOLORRGB',rc.5
CALL VpItem _eCALCPMHandleMain, 1009,'FORECOLORRGB',rc.5
CALL VpItem _eCALCPMHandleMain, 1010,'FORECOLORRGB',rc.5
CALL VpItem _eCALCPMHandleMain, 1012,'FORECOLORRGB',rc.5
CALL VpItem _eCALCPMHandleMain, 1017,'FORECOLORRGB',rc.5

CALL VpItem _eCALCPMHandleMain, 1011,'FORECOLORRGB',rc.6
CALL VpItem _eCALCPMHandleMain, 1013,'FORECOLORRGB',rc.6
CALL VpItem _eCALCPMHandleMain, 1014,'FORECOLORRGB',rc.6
CALL VpItem _eCALCPMHandleMain, 1015,'FORECOLORRGB',rc.6
CALL VpItem _eCALCPMHandleMain, 1016,'FORECOLORRGB',rc.6
CALL VpItem _eCALCPMHandleMain, 1020,'FORECOLORRGB',rc.6
CALL VpItem _eCALCPMHandleMain, 1021,'FORECOLORRGB',rc.6

CALL VpItem _eCALCPMHandleMain, 1000,'FORECOLORRGB',rc.7
CALL VpItem _eCALCPMHandleMain, 1001,'FORECOLORRGB',rc.8

/* set fonts */

CALL VpItem _eCALCPMHandleMain, 1002,'FONT', rc.9
CALL VpItem _eCALCPMHandleMain, 1003,'FONT', rc.9
CALL VpItem _eCALCPMHandleMain, 1004,'FONT', rc.9
CALL VpItem _eCALCPMHandleMain, 1005,'FONT', rc.9
CALL VpItem _eCALCPMHandleMain, 1006,'FONT', rc.9
CALL VpItem _eCALCPMHandleMain, 1007,'FONT', rc.9
CALL VpItem _eCALCPMHandleMain, 1008,'FONT', rc.9
CALL VpItem _eCALCPMHandleMain, 1009,'FONT', rc.9
CALL VpItem _eCALCPMHandleMain, 1010,'FONT', rc.9
CALL VpItem _eCALCPMHandleMain, 1012,'FONT', rc.9
CALL VpItem _eCALCPMHandleMain, 1017,'FONT', rc.9

CALL VpItem _eCALCPMHandleMain, 1011,'FONT', rc.10
CALL VpItem _eCALCPMHandleMain, 1013,'FONT', rc.10
CALL VpItem _eCALCPMHandleMain, 1014,'FONT', rc.10
CALL VpItem _eCALCPMHandleMain, 1015,'FONT', rc.10
CALL VpItem _eCALCPMHandleMain, 1016,'FONT', rc.10
CALL VpItem _eCALCPMHandleMain, 1020,'FONT', rc.10
CALL VpItem _eCALCPMHandleMain, 1021,'FONT', rc.10

CALL VpItem _eCALCPMHandleMain, 1000,'FONT',rc.11
CALL VpItem _eCALCPMHandleMain, 1001,'FONT',rc.12

return

/* ##SUB__ecalccalculate */
_ecalccalculate: /* _eCALCcalculate */


NUMERIC DIGITS NumericDigits


SIGNAL ON syntax NAME ERR

_eCALCstring = VpGetItemValue(_eCALCPMHandleMain, 1001)

call Value "ECALCEXPRESSION", _eCALCstring, "OS2ENVIRONMENT"

  _eCALCstring = translate(_eCALCstring, '.', ',')

interpret "_eCALCvalue = "|| _eCALCstring

if _eCALCprecision = -2 & _eCALCprecision >< -1 then _eCALCvalue = format(_eCALCvalue,,_eCALCsystemprecision)
else if _eCALCprecision >< "" & _eCALCprecision >< "-1" then _eCALCvalue = format(_eCALCvalue,,_eCALCprecision)

  _eCALCvalue = translate(_eCALCvalue, _eCALCdelimiter, '.')


_eCALCrc= VpSetItemValue(_eCALCPMHandleMain, 1000, _eCALCvalue)

if _eCALCAuotClip = 1 then CALL VpWindow _eCALCPMHandleMain,'SETCLIPBOARD','TEXT',_eCALCvalue

/* set result to environment variiable */
call Value "ECALCRESULT", _eCALCvalue, "OS2ENVIRONMENT"

return

ERR:
rc=VpSetItemValue(_eCALCPMHandleMain, 1000,"")
return

/* ##SUB__ecalccopyfromclipboard */
_ecalccopyfromclipboard: /*_eCALCCopyFromClipBoard*/
/* inserts only the frist line from clipboard */
_eCALCP_string=""
parse value VpWindow(_eCALCPMHandleMain,'GETCLIPBOARD','TEXT') with _eCALCP_string '0d'x _eCALCPdummy
CALL VpAddItem _eCALCPMHandleMain, 1001, 'CURRENT', _eCALCP_string
drop _eCALCP_string _eCALCPdummy


return

/* ##SUB__ecalcfloat */
_ecalcfloat: /* */
Procedure
arg hwndFrame , flag  , _eCALCPMHandleMain
QWL_STYLE = -2
select
when flag = 1 then do 
	rc = apixWinSetWindowBits(hwndFrame, QWL_STYLE, 0x200000, 0x200000)
	CALL VpWindow _eCALCPMHandleMain, 'ACTIVATE'
	end
when flag = 0 then rc = apixWinSetWindowBits(hwndFrame, QWL_STYLE, 0, 0x200000)
otherwise rc = "ERROR:"
end
return(rc)
/* ##SUB__ecalcinitfloat */
_ecalcinitfloat: /* */
PROCEDURE
arg handle
/* if RxFuncQuery(apixLoadFuncs) >< 0 then */
do
call RxFuncAdd 'apixLoadFuncs', 'OS2apirx', 'apixLoadFuncs' 
call apixLoadFuncs
end

QW_PARENT = 5

hwndClient = apixWinQueryWindow( handle, QW_PARENT )
hwndFrame  = apixWinQueryWindow( hwndClient, QW_PARENT )

return(hwndFrame)
/* ##SUB__ecalcputinbrackets */
_ecalcputinbrackets: /*_eCALCPutInBrackets*/
/* puts the marked chars into brackets */


_range=VpGetIndex(_eCALCPMHandleMain,1001) 

PARSE VAR _range _first _last 

_temp_value=VpGetItemValue(_eCALCPMHandleMain, 1001) 

call VpSetItemValue _eCALCPMHandleMain, 1001,  substr(_temp_value,1,_first) ||"("|| substr(_temp_value,_first+1,_last-_first) ||")"|| substr(_temp_value,_last+1) 

drop _temp_value _first _last _range



return

/* ##SUB__ecalcreadlang */
_ecalcreadlang: /* read languagefile to RAM */ 

_eCALCMain_i=0
_eCALCNB1_i=0
do until lines(_eCALClanguagefile) = 0
 _eCALCrc=linein(_eCALClanguagefile)

parse var _eCALCrc _eCALCFrameId . _eCALCItemId _eCALCItemString

/* main window */
if _eCALCFrameId = "MAIN" then do
_eCALCMain_i=_eCALCMain_i+1
_eCALCMAINstring._eCALCMain_i.1=_eCALCItemId
_eCALCMAINstring._eCALCMain_i.2=strip(_eCALCItemString,'B', '"')
end

/* notebookpage 1 */
if _eCALCFrameId = "NB1" then do
_eCALCNB1_i=_eCALCNB1_i+1
_eCALCNB1string._eCALCNB1_i.1=_eCALCItemId
_eCALCNB1string._eCALCNB1_i.2=strip(_eCALCItemString,'B', '"')
end



end /* do until lines ...*/

_eCALCMAINstring.0=_eCALCMain_i
_eCALCNB1string.0=_eCALCNB1_i

call stream _eCALClanguagefile, "C", "CLOSE"


return

/* ##SUB__ecalcsetlang */
_ecalcsetlang: /* set language strings to items */ 
arg _eCalcWindow

if translate(stream(_eCALClanguagefile,"C",QUERY EXISTS)) = translate(_eCALClanguagefile) then do

Select
when _eCalcWindow='MAIN' then do
	do _eCalc_i = 1 to _eCALCMAINstring.0
         call VpSetItemValue _eCALCPMHandleMain, _eCALCMAINstring._eCalc_i.1, _eCALCMAINstring._eCalc_i.2
	end
end
when _eCalcWindow='NB1' then do
	do _eCalc_i=1 to _eCALCNB1string.0
	Select
         when _eCALCNB1string._eCalc_i.1=260 then CALL VpSetItemValue _eCALCPMHandleSettings, 1000, 'TABTEXT',_eCALCPMHandleNumColindex, _eCALCNB1string._eCalc_i.2
	 when _eCALCNB1string._eCalc_i.1=257 then call VpWindow _eCALCPMHandleSettings,'SETTITLE', _eCALCNB1string._eCalc_i.2
	 otherwise call VpSetItemValue _eCALCPMHandleNumCol, _eCALCNB1string._eCalc_i.1, _eCALCNB1string._eCalc_i.2
	end /*select*/
	end
end
OTHERWISE NOP
end

end
return

/* ##SUB__ecalcsetprecision */
_ecalcsetprecision: /* _eCALCSetPrecision */
arg _eCALCPrec
do _eCALC_i = 303 to 314
if _eCALC_i == _eCALCPrec then do
	call VpSelect _eCALCPMHandleMain, _eCALC_i, 1
Select
when _eCALCPrec = 313 then _eCALCprecision = -1 /* disable */
when _eCALCPrec = 314 then _eCALCprecision = -2 /* default, use system setting */
otherwise _eCALCprecision = _eCALC_i - 303
end /* select*/

end
else call VpSelect _eCALCPMHandleMain, _eCALC_i, 0
end

call _eCALCcalculate
return
